"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseOverlayView = exports.BaseOverlayModel = void 0;
// Copyright (c) QuantStack
// Distributed under the terms of the Modified BSD License.
const base_1 = require("@jupyter-widgets/base");
require("ol/ol.css");
const version_1 = require("./version");
require("../css/widget.css");
const Overlay_1 = __importDefault(require("ol/Overlay"));
class BaseOverlayModel extends base_1.DOMWidgetModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: BaseOverlayModel.model_name, _model_module: BaseOverlayModel.model_module, _model_module_version: BaseOverlayModel.model_module_version, _view_name: BaseOverlayModel.view_name, _view_module: BaseOverlayModel.view_module, _view_module_version: BaseOverlayModel.view_module_version });
    }
}
exports.BaseOverlayModel = BaseOverlayModel;
BaseOverlayModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
BaseOverlayModel.model_name = 'BaseOverlayModel';
BaseOverlayModel.model_module = version_1.MODULE_NAME;
BaseOverlayModel.model_module_version = version_1.MODULE_VERSION;
BaseOverlayModel.view_name = 'BaseOverlayView';
BaseOverlayModel.view_module = version_1.MODULE_NAME;
BaseOverlayModel.view_module_version = version_1.MODULE_VERSION;
class BaseOverlayView extends base_1.DOMWidgetView {
    render() {
        super.render();
        this.createElement();
        this.createOverlay();
        this.model_events();
    }
    createOverlay() {
        const position = this.model.get('position');
        this.overlay = new Overlay_1.default({
            position: position,
            element: this.element,
        });
        return this.overlay;
    }
    model_events() {
        this.listenTo(this.model, 'change:position', this.updatePosition);
    }
    updatePosition() {
        const position = this.model.get('position');
        this.overlay.setPosition(position);
    }
}
exports.BaseOverlayView = BaseOverlayView;
//# sourceMappingURL=baseoverlay.js.map