"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GeoTIFFTileLayerView = exports.GeoTIFFTileLayerModel = void 0;
// Copyright (c) QuantStack
// Distributed under the terms of the Modified BSD License.
const base_1 = require("@jupyter-widgets/base");
const WebGLTile_js_1 = __importDefault(require("ol/layer/WebGLTile.js"));
const GeoTIFF_js_1 = __importDefault(require("ol/source/GeoTIFF.js"));
const version_1 = require("./version");
const layer_1 = require("./layer");
class GeoTIFFTileLayerModel extends layer_1.LayerModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: GeoTIFFTileLayerModel.model_name, _model_module: GeoTIFFTileLayerModel.model_module, _model_module_version: GeoTIFFTileLayerModel.model_module_version, _view_name: GeoTIFFTileLayerModel.view_name, _view_module: GeoTIFFTileLayerModel.view_module, _view_module_version: GeoTIFFTileLayerModel.view_module_version, url: '' });
    }
}
exports.GeoTIFFTileLayerModel = GeoTIFFTileLayerModel;
GeoTIFFTileLayerModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
GeoTIFFTileLayerModel.model_name = 'GeoTIFFTileLayerModel';
GeoTIFFTileLayerModel.model_module = version_1.MODULE_NAME;
GeoTIFFTileLayerModel.model_module_version = version_1.MODULE_VERSION;
GeoTIFFTileLayerModel.view_name = 'GeoTIFFTileLayerView';
GeoTIFFTileLayerModel.view_module = version_1.MODULE_NAME;
GeoTIFFTileLayerModel.view_module_version = version_1.MODULE_VERSION;
class GeoTIFFTileLayerView extends layer_1.LayerView {
    render() {
        super.render();
        this.sourcesChanged();
        this.model.on('change:url', this.sourcesChanged, this);
    }
    create_obj() {
        const url = this.model.get('url');
        if (url) {
            this.obj = new WebGLTile_js_1.default({
                source: new GeoTIFF_js_1.default({
                    sources: [{ url: url }],
                }),
            });
        }
    }
    sourcesChanged() {
        const newUrl = this.model.get('url');
        if (newUrl) {
            const newSource = new GeoTIFF_js_1.default({
                sources: [{ url: newUrl }],
            });
            this.obj.setSource(newSource);
        }
    }
}
exports.GeoTIFFTileLayerView = GeoTIFFTileLayerView;
//# sourceMappingURL=geotifflayer.js.map