"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImageOverlayView = exports.ImageOverlayModel = void 0;
// Copyright (c) QuantStack
// Distributed under the terms of the Modified BSD License.
const base_1 = require("@jupyter-widgets/base");
const baseoverlay_1 = require("./baseoverlay");
require("ol/ol.css");
const version_1 = require("./version");
require("../css/widget.css");
class ImageOverlayModel extends baseoverlay_1.BaseOverlayModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: ImageOverlayModel.model_name, _model_module: ImageOverlayModel.model_module, _model_module_version: ImageOverlayModel.model_module_version, _view_name: ImageOverlayModel.view_name, _view_module: ImageOverlayModel.view_module, _view_module_version: ImageOverlayModel.view_module_version, image_url: '' });
    }
}
exports.ImageOverlayModel = ImageOverlayModel;
ImageOverlayModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
ImageOverlayModel.model_name = 'ImageOverlayModel';
ImageOverlayModel.model_module = version_1.MODULE_NAME;
ImageOverlayModel.model_module_version = version_1.MODULE_VERSION;
ImageOverlayModel.view_name = 'ImageOverlayView';
ImageOverlayModel.view_module = version_1.MODULE_NAME;
ImageOverlayModel.view_module_version = version_1.MODULE_VERSION;
class ImageOverlayView extends baseoverlay_1.BaseOverlayView {
    render() {
        super.render();
        this.updateImageElement();
    }
    createElement() {
        this.element = document.createElement('img');
    }
    model_events() {
        super.model_events();
        this.listenTo(this.model, 'change:image_url', this.updateImageElement);
    }
    updateImageElement() {
        const imageUrl = this.model.get('image_url');
        if (imageUrl) {
            this.element.src = imageUrl;
        }
    }
}
exports.ImageOverlayView = ImageOverlayView;
//# sourceMappingURL=imageoverlay.js.map