"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PopupOverlayView = exports.PopupOverlayModel = void 0;
// Copyright (c) QuantStack
// Distributed under the terms of the Modified BSD License.
const base_1 = require("@jupyter-widgets/base");
require("ol/ol.css");
const version_1 = require("./version");
require("../css/widget.css");
const baseoverlay_1 = require("./baseoverlay");
class PopupOverlayModel extends baseoverlay_1.BaseOverlayModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: PopupOverlayModel.model_name, _model_module: PopupOverlayModel.model_module, _model_module_version: PopupOverlayModel.model_module_version, _view_name: PopupOverlayModel.view_name, _view_module: PopupOverlayModel.view_module, _view_module_version: PopupOverlayModel.view_module_version });
    }
}
exports.PopupOverlayModel = PopupOverlayModel;
PopupOverlayModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
PopupOverlayModel.model_name = 'PopupOverlayModel';
PopupOverlayModel.model_module = version_1.MODULE_NAME;
PopupOverlayModel.model_module_version = version_1.MODULE_VERSION;
PopupOverlayModel.view_name = 'PopupOverlayView';
PopupOverlayModel.view_module = version_1.MODULE_NAME;
PopupOverlayModel.view_module_version = version_1.MODULE_VERSION;
class PopupOverlayView extends baseoverlay_1.BaseOverlayView {
    render() {
        super.render();
        this.updatePopupElement();
    }
    createElement() {
        this.element = document.createElement('div');
    }
    model_events() {
        super.model_events();
        this.listenTo(this.model, 'change:popup_content', this.updatePopupElement);
    }
    updatePopupElement() {
        const popupContent = this.model.get('popup_content');
        if (popupContent) {
            this.element.innerHTML = popupContent;
        }
    }
}
exports.PopupOverlayView = PopupOverlayView;
//# sourceMappingURL=popupoverlay.js.map