"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RasterTileLayerView = exports.RasterTileLayerModel = void 0;
// Copyright (c) QuantStack
// Distributed under the terms of the Modified BSD License.
const base_1 = require("@jupyter-widgets/base");
const WebGLTile_js_1 = __importDefault(require("ol/layer/WebGLTile.js"));
const XYZ_js_1 = __importDefault(require("ol/source/XYZ.js"));
const version_1 = require("./version");
const layer_1 = require("./layer");
class RasterTileLayerModel extends layer_1.LayerModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: RasterTileLayerModel.model_name, _model_module: RasterTileLayerModel.model_module, _model_module_version: RasterTileLayerModel.model_module_version, _view_name: RasterTileLayerModel.view_name, _view_module: RasterTileLayerModel.view_module, _view_module_version: RasterTileLayerModel.view_module_version, layers: [], url: '', attributions: [], tileSize: 256, max_zoom: 19, min_zoom: 0 });
    }
}
exports.RasterTileLayerModel = RasterTileLayerModel;
RasterTileLayerModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
RasterTileLayerModel.model_name = 'RasterTileLayerModel';
RasterTileLayerModel.model_module = version_1.MODULE_NAME;
RasterTileLayerModel.model_module_version = version_1.MODULE_VERSION;
RasterTileLayerModel.view_name = 'RasterTileLayerView';
RasterTileLayerModel.view_module = version_1.MODULE_NAME;
RasterTileLayerModel.view_module_version = version_1.MODULE_VERSION;
class RasterTileLayerView extends layer_1.LayerView {
    render() {
        super.render();
        this.urlChanged();
        this.model.on('change:url', this.urlChanged, this);
    }
    create_obj() {
        this.obj = this.tileLayer = new WebGLTile_js_1.default({
            source: new XYZ_js_1.default({
                url: this.model.get('url'),
                attributions: this.model.get('attributions'),
                tileSize: this.model.get('tileSize'),
                maxZoom: this.model.get('max_zoom'),
                minZoom: this.model.get('min_zoom'),
            }),
        });
    }
    urlChanged() {
        const newUrl = this.model.get('url');
        if (newUrl) {
            const newSource = new XYZ_js_1.default({
                url: newUrl,
                attributions: this.model.get('attributions'),
                tileSize: this.model.get('tileSize'),
                maxZoom: this.model.get('max_zoom'),
                minZoom: this.model.get('min_zoom'),
            });
            this.tileLayer.setSource(newSource);
        }
    }
}
exports.RasterTileLayerView = RasterTileLayerView;
//# sourceMappingURL=rastertilelayer.js.map