"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VideoOverlayView = exports.VideoOverlayModel = void 0;
// Copyright (c) QuantStack
// Distributed under the terms of the Modified BSD License.
const base_1 = require("@jupyter-widgets/base");
require("ol/ol.css");
const version_1 = require("./version");
require("../css/widget.css");
const baseoverlay_1 = require("./baseoverlay");
class VideoOverlayModel extends baseoverlay_1.BaseOverlayModel {
    defaults() {
        return Object.assign(Object.assign({}, super.defaults()), { _model_name: VideoOverlayModel.model_name, _model_module: VideoOverlayModel.model_module, _model_module_version: VideoOverlayModel.model_module_version, _view_name: VideoOverlayModel.view_name, _view_module: VideoOverlayModel.view_module, _view_module_version: VideoOverlayModel.view_module_version });
    }
}
exports.VideoOverlayModel = VideoOverlayModel;
VideoOverlayModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
VideoOverlayModel.model_name = 'VideoOverlayModel';
VideoOverlayModel.model_module = version_1.MODULE_NAME;
VideoOverlayModel.model_module_version = version_1.MODULE_VERSION;
VideoOverlayModel.view_name = 'VideoOverlayVIew';
VideoOverlayModel.view_module = version_1.MODULE_NAME;
VideoOverlayModel.view_module_version = version_1.MODULE_VERSION;
class VideoOverlayView extends baseoverlay_1.BaseOverlayView {
    render() {
        super.render();
        this.updateVideoElement();
    }
    createElement() {
        this.element = document.createElement('div');
        this.videoElement = document.createElement('video');
        this.videoElement.controls = true;
        this.element.appendChild(this.videoElement);
    }
    model_events() {
        super.model_events();
        this.listenTo(this.model, 'change:video_url', this.updateVideoElement);
    }
    updateVideoElement() {
        const videoUrl = this.model.get('video_url');
        if (videoUrl) {
            this.videoElement.src = videoUrl;
        }
    }
}
exports.VideoOverlayView = VideoOverlayView;
//# sourceMappingURL=video_overlay.js.map